package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.pojo.PageParam;
import com.zt.plat.framework.common.util.object.BeanUtils;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigQCSampleMethodDO;
import com.zt.plat.module.qms.business.config.dal.mapper.ConfigQCSampleMethodMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.diffList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.*;

/**
 * 质控样与检测方法配置 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class ConfigQCSampleMethodServiceImpl implements ConfigQCSampleMethodService {

    @Resource
    private ConfigQCSampleMethodMapper configQCSampleMethodMapper;

    @Override
    public ConfigQCSampleMethodRespVO createConfigQCSampleMethod(ConfigQCSampleMethodSaveReqVO createReqVO) {
        // 插入
        ConfigQCSampleMethodDO configQCSampleMethod = BeanUtils.toBean(createReqVO, ConfigQCSampleMethodDO.class);
        configQCSampleMethodMapper.insert(configQCSampleMethod);
        // 返回
        return BeanUtils.toBean(configQCSampleMethod, ConfigQCSampleMethodRespVO.class);
    }

    @Override
    public void updateConfigQCSampleMethod(ConfigQCSampleMethodSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigQCSampleMethodExists(updateReqVO.getId());
        // 更新
        ConfigQCSampleMethodDO updateObj = BeanUtils.toBean(updateReqVO, ConfigQCSampleMethodDO.class);
        configQCSampleMethodMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigQCSampleMethod(Long id) {
        // 校验存在
        validateConfigQCSampleMethodExists(id);
        // 删除
        configQCSampleMethodMapper.deleteById(id);
    }

    @Override
        public void deleteConfigQCSampleMethodListByIds(List<Long> ids) {
        // 校验存在
        validateConfigQCSampleMethodExists(ids);
        // 删除
        configQCSampleMethodMapper.deleteByIds(ids);
        }

    private void validateConfigQCSampleMethodExists(List<Long> ids) {
        List<ConfigQCSampleMethodDO> list = configQCSampleMethodMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_QC_SAMPLE_METHOD_NOT_EXISTS);
        }
    }

    private void validateConfigQCSampleMethodExists(Long id) {
        if (configQCSampleMethodMapper.selectById(id) == null) {
            throw exception(CONFIG_QC_SAMPLE_METHOD_NOT_EXISTS);
        }
    }

    @Override
    public ConfigQCSampleMethodDO getConfigQCSampleMethod(Long id) {
        return configQCSampleMethodMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigQCSampleMethodDO> getConfigQCSampleMethodPage(ConfigQCSampleMethodPageReqVO pageReqVO) {
        return configQCSampleMethodMapper.selectPage(pageReqVO);
    }

}